#!/bin/sh

[ -d 'src' ] || exit

echo -n "Cache time-out in seconds: [300] "

read cachetimeout
[ "$cachetimeout" = "" ] && cachetimeout=300

echo -n "Max cache entries? [16] "
read entries
[ "$entries" = "" ] && entries=16

echo -n "Debug level? (0=none, increasing=more) [0] "
read dbg
[ "$dbg" = "" ] && dbg=0

echo -n "Store passwords encrypted? (MD5 library must be available) [y] "
read md5
m="#undef MAA_USE_MD5"
[ "$md5" = "y" ] || [ "$md5" = "Y" ] || [ "$md5" = "" ] && m="#define MAA_USE_MD5 1"

cat <<EOF > src/maa_config.h
#ifndef MAA_CONFIG
#define MAA_CONFIG
/* cache timeout in seconds */
#define MAA_CACHE_EXPIRE $cachetimeout

#define MAA_DEBUGLVL $dbg
#define MAA_MAX_CACHE_ENTRIES $entries

$m

#endif
EOF

md5="yes"
[ "$m" = "#undef MAA_USE_MD5" ] && md5="no"

cat <<EOF
-------------------------------------
Cache time-out: $cachetimeout seconds
Max cache entries: $entries
Debug level: $dbg
Store passwords encrypted: $md5
-------------------------------------

If this is incorrect, please re-run this configure script.
Otherwise, you can run make.
EOF
