/* mod_auth_any supporting functions */
#include "maa_support.h"

#ifndef strnlen
/* override strnlen() */
size_t strnlen(const char* p, size_t l) {
    int i;
    for (i = 0; (i < l) && ('\0' != *p++ ); ++i);
    return i;
}
#endif

#ifndef memcmp
int memcmp(const void *s1, const void *s2, size_t n) {
	int i;
	char *p1;
	char *p2;
	p1=(char *)s1;
	p2=(char *)p2;
	for(i=0;i<n;i++) {
		if(*p1>*p2) return 1;
		if(*p1<*p2) return -1;
		p1++;p2++;
	}
	return 0;
}
#endif


#ifndef strndup
/* override strndup() */
char *strndup(const char *s,int n) {
    char *g;
    if(n>MAA_BUFLEN) n=MAA_BUFLEN;
    if(n<=0) return NULL;
    if(n<1) n=1;
    g=(char *)malloc(n);
    if(g==NULL) {
        return NULL;
    }
    g[n-1]='\0';
    strncpy(g,s,n-1);
    return g;
}
#endif


char ** split(char d,char *str) {
    /*
     * Satyajit Phanse phanse at musc.edu 2003 05 06
     *
     * This split function is similar to perl, but takes only a character as
     * the delimiter. The second parameter is the null-terminated string to
     * split.
     *
     * Return: pointer to array of strings containing the split values. The
     * last element of the array is NULL. The delimiters will be eaten.
     */
    char **r;
    int i,j;
    char *buf;
    char *p;

    if((r=(char **)malloc( (strlen(str)+2)*sizeof(char *) )  )==NULL) {
        return NULL;
    }

    if((buf=(char *)malloc( (strlen(str)+1)*sizeof(char) )  )==NULL) {
        free(r);
        return NULL;
    }

    p=str;
    i=0;
    j=0;
    while(p!=NULL && *p!='\0') {
        if(*p==d)   {
            buf[i]='\0';
            if((r[j]=(char *)malloc((strlen(buf)+1)*sizeof(char)))==NULL) {
                free(buf);
                free(r);
                return NULL;
            }
            if(strlen(buf)<1) strncpy(r[j],"\0",2);
            else strncpy(r[j],buf,strlen(buf)+1);
            j++;
            i=0;
        }
        else    {
            buf[i++]=*p;
        }
        p++;
    }

    buf[i]='\0';
    if((r[j]=(char *)malloc((strlen(buf)+1)*sizeof(char)))==NULL) {
        free(buf);
        free(r);
        return NULL;
    }
    if(strlen(buf)<1) strncpy(r[j],"\0",2);
    else strncpy(r[j],buf,strlen(buf)+1);
    j++;
    r[j]=NULL;

    free(buf);

    return r;
} /* split() */

