#ifndef MOD_AUTH_ANY
#define MOD_AUTH_ANY

#include "maa_config.h"
/* Our preferred maximum buffer length */
#define MAA_BUFLEN 256

#include "httpd.h"
#include "http_config.h"
#include "http_core.h"
#include "http_log.h"
#include "http_protocol.h"

#ifdef WITH_APACHE2

#define APR_WANT_STRFUNC
#include "apr_want.h"
#include "apr_md5.h"            /* for apr_password_validate */
#include "apr_strings.h"
#include "ap_config.h"
#include "http_request.h"   /* for ap_hook_(check_user_id | auth_checker)*/
#include <unistd.h>
/* for threading: */
#include "ap_mpm.h"
#include "apr_thread_mutex.h"

#else

#include <multithread.h>

#endif


#ifdef MAA_USE_MD5
  #ifdef WITH_APACHE2
    #include "apr_md5.h"
  #else
    #include "util_md5.h"
    #define APR_MD5_DIGESTSIZE 64
  #endif
  #define MAA_PASS encpass
  #define MAA_PASSSIZE APR_MD5_DIGESTSIZE
#else
  #define MAA_PASS password
#endif

#include <time.h>
#include <stdio.h>
#include <string.h>
#include <stddef.h>

/* locking macros based on code copied from mod_auth_ldap */
#ifdef WITH_APACHE2
#define TMPM_LOCK() if (mx) apr_thread_mutex_lock(mx)
#define TMPM_UNLOCK() if (mx) apr_thread_mutex_unlock(mx)
#else
#define TMPM_LOCK() if (mx) (void) ap_acquire_mutex(mx)
#define TMPM_UNLOCK() if (mx) (void) ap_release_mutex(mx)
#endif

/* stuff that changes with apache/apache2 -- waaay too much of this.*/

        #ifdef WITH_APACHE2
#define MAA_LOGERROR 0,r
#define MAA_POOL apr_pool_t
#define MAA_PCALLOC apr_palloc
#define MAA_TABLE apr_table_t
#define MAA_TABLE_MAKE apr_table_make
#define MAA_STRCAT apr_pstrcat

#define MAA_AP_INIT(x,y,z) AP_INIT_TAKE12(x,set_auth_slot, (void *)APR_OFFSETOF(auth_config_rec, y),OR_AUTHCFG,z)

#define MAA_AP_FLAG(x,y,z) AP_INIT_FLAG(x,ap_set_flag_slot,(void *)APR_OFFSETOF(auth_config_rec, y),OR_AUTHCFG,z)

#define MAA_UNAUTH HTTP_UNAUTHORIZED
        #else
#define MAA_LOGERROR r
#define MAA_POOL pool
#define MAA_PCALLOC ap_pcalloc
#define MAA_TABLE table
#define MAA_TABLE_MAKE ap_make_table
#define MAA_STRCAT ap_pstrcat
#define MAA_UNAUTH AUTH_REQUIRED
#define MAA_AP_INIT(x,y,z) {x,set_auth_slot, (void *)XtOffsetOf(auth_config_rec, y),OR_AUTHCFG,TAKE12,z}
#define MAA_AP_FLAG(x,y,z) {x,ap_set_flag_slot,(void *) XtOffsetOf(auth_config_rec, y), OR_AUTHCFG, FLAG,z}
#define apr_thread_mutex_t mutex
        #endif

#define MAA_ERROR APLOG_MARK,APLOG_ERR,MAA_LOGERROR
#define MAA_ERROR2 APLOG_MARK,APLOG_NOERRNO|APLOG_ERR,MAA_LOGERROR
#define MAA_DEBUG APLOG_MARK,APLOG_DEBUG,MAA_LOGERROR

#include "maa_cache.h"
#include "maa_support.h"

#endif /* MOD_AUTH_ANY */
